/************************************************
top_bits[] is a xbm file (not x10 format)
************************************************/
#include <stdio.h>
#include <stdlib.h>

#define SHORT_LENGTH 8
#define BYTE_LENGTH 8

// Invert image
#define INVERT 0

// good choice: pitboy_width % 8 == 0
// good choice: pitboy_height % 8 == 0
#define pitboy_width 40
#define pitboy_height 32
static unsigned char pitboy_bits[] = {
   0x00, 0x00, 0x7e, 0x00, 0x00, 0x00, 0xe0, 0x8f, 0x07, 0x00, 0x00, 0x18,
   0xb1, 0x18, 0x00, 0x00, 0x86, 0xe0, 0x70, 0x00, 0x00, 0x81, 0xff, 0xdf,
   0x00, 0xc0, 0x80, 0x58, 0x23, 0x03, 0x60, 0x80, 0x40, 0x20, 0x06, 0x20,
   0x80, 0x40, 0x20, 0x0c, 0x10, 0x80, 0xe0, 0x10, 0x08, 0x08, 0x00, 0x31,
   0x19, 0x10, 0x08, 0x00, 0x7f, 0x07, 0x1c, 0x04, 0x00, 0xf0, 0x03, 0x20,
   0x04, 0x00, 0xf0, 0x01, 0x27, 0x02, 0xfe, 0xe1, 0xe0, 0x21, 0x02, 0x00,
   0x40, 0x00, 0x20, 0x02, 0x00, 0x40, 0x00, 0x40, 0x22, 0xf0, 0x43, 0xe0,
   0x47, 0x12, 0x1f, 0x40, 0x00, 0x4c, 0x12, 0x00, 0x40, 0x00, 0x40, 0x12,
   0x00, 0x42, 0x20, 0x40, 0x12, 0xe0, 0x43, 0xe0, 0x43, 0x12, 0x1c, 0xf0,
   0x01, 0x4e, 0x12, 0x02, 0x1c, 0x0e, 0x40, 0x14, 0x80, 0x03, 0x30, 0x20,
   0x34, 0x60, 0x00, 0xc0, 0x20, 0x38, 0x18, 0x00, 0x00, 0x21, 0x28, 0x04,
   0x00, 0x00, 0x12, 0x70, 0x02, 0x00, 0x00, 0x08, 0x60, 0x00, 0x00, 0x00,
   0x0c, 0xc0, 0x00, 0x00, 0x00, 0x04, 0x80, 0x01, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00 };
   
void printDisplay(unsigned char * display) {
	int i,j;
	int c=0;
	for( i=0; i<pitboy_height; i++){
		for( j=0; j<pitboy_width; j++){
			if(c%8 == 0) printf("B");
			if (display[i*pitboy_width+j] != 0) {
				printf("1");
			}else{
				printf("0");
			}
			if(c%8 == 7) printf(",");
			c++;
		}
		printf("\n");
	}
	printf("\n");
}

unsigned char * expandBitMap(
	unsigned char * bits,
	unsigned char * display
) {
	int i,j;
	for (i = 0; i<(pitboy_width*pitboy_height/SHORT_LENGTH); i++) {
		for (j=0; j<SHORT_LENGTH; j++) {
			display[i*SHORT_LENGTH + j] = (bits[i] & (1 << j)) >> j;
			if (INVERT == 1) {
				if (display[i*SHORT_LENGTH + j] == 0)
					display[i*SHORT_LENGTH + j] = 1;
				else
					display[i*SHORT_LENGTH + j] = 0;
			}
		}
	}
	return display;
}

int main() {
	unsigned char * display = malloc(pitboy_width*pitboy_height);
	display = expandBitMap(pitboy_bits,display);
	printDisplay(display);
	free(display);
	return 0;
}
